Lorene::Eos_mag Class Reference
Equations of state

Class for a magnetized (tabulated) equation of state. More...

`#include <eos_mag.h>`

Inheritance diagram for Lorene::Eos_mag:

## Public Member Functions

virtual | ~Eos_mag ()
| Destructor.
virtual bool | operator== (const Eos &) const
| Comparison operator (egality).
virtual bool | operator!= (const Eos &) const
| Comparison operator (difference).
virtual int | identify () const
| Returns a number to identify the sub-classe of `Eos` the object belongs to.
virtual void | sauve (FILE *) const
| Save in a file.
double | mag_ent_p (double ent, const Param *par=0x0) const
| Computes the magnetisation.
virtual double | nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the baryon density from the log-enthalpy.
virtual double | ener_ent_p (double ent, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy.
virtual double | press_ent_p (double ent, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy.
virtual double | der_nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_ener_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_press_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_press_nbar_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
const char * | get_name () const
| Returns the EOS name.
void | set_name (const char *name_i)
| Sets the EOS name.
Cmp | nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Scalar | nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Cmp | ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Scalar | ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Cmp | press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Scalar | press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Cmp | der_nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.

## Static Public Member Functions

static Eos * | eos_from_file (FILE *)
| Construction of an EOS from a binary file.
static Eos * | eos_from_file (ifstream &)
| Construction of an EOS from a formatted file.

## Protected Member Functions

| Eos_mag (const char *name_i, const char *table, const char *path)
| Standard constructor.
| Eos_mag (const char *name_i, const char *file_name)
| Standard constructor from the full filename.
| Eos_mag (const Eos_mag &)
| Copy constructor.
| Eos_mag (FILE *)
| Constructor from a binary file (created by the function `sauve(FILE*)` ).
| Eos_mag (ifstream &ist, const char *table)
| Constructor from a formatted file.
| Eos_mag (ifstream &ist)
| Constructor from a formatted file.
void | read_table ()
| Reads the file containing the table and initializes in the arrays `logh` , `logp` and `dlpsdlh` .
virtual ostream & | operator>> (ostream &) const
| Operator >>.
void | calcule (const Cmp &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Cmp &resu) const
| General computational method for `Cmp` 's.
void | calcule (const Scalar &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Scalar &resu) const
| General computational method for `Scalar` 's.

## Protected Attributes

string | tablename
| Name of the file containing the tabulated data.
double | hmin
| Lower boundary of the log-enthalpy interval.
double | hmax
| Upper boundary of the log-enthalpy interval.
double | Bmax
| Upper boundary of the magnetic field interval.
Tbl * | logp
| Table of .
Tbl * | logh
| Table of .
Tbl * | Bfield
| Table of .
Tbl * | dlpsdlh
| Table of .
Tbl * | dlpsdB
| Table of .
Tbl * | d2lp
| Table of .
char | name [100]
| EOS name.

## Friends

Eos * | Eos::eos_from_file (FILE *)
| The construction functions from a file.
Eos * | Eos::eos_from_file (ifstream &)

## Detailed Description

Class for a magnetized (tabulated) equation of state.

()

This EOS depends on two variables : density (or log-enthalpy) and the magnetic field amplitude. The interpolation through the tables is a cubic Hermite interpolation, which is thermodynamically consistent, i.e. preserves the Gibbs-Duhem relation.

Definition at line 78 of file eos_mag.h.

## Constructor & Destructor Documentation

## Eos_mag() [1/6]

Lorene::Eos_mag::Eos_mag | ( | const char * | name_i,
|  | const char * | table,
|  | const char * | path )

protected

Standard constructor.

Parameters

  name_i | Name of the equation of state
  table | Name of the file containing the EOS table
  path | Path to the directory containing the EOS file

Definition at line 98 of file eos_mag.C.

References Lorene::Eos::Eos(), read_table(), and tablename.

## Eos_mag() [2/6]

Lorene::Eos_mag::Eos_mag | ( | const char * | name_i,
|  | const char * | file_name )

protected

Standard constructor from the full filename.

Parameters

  name_i | Name of the equation of state
  table | Full name of the file containing the EOS table (including the absolute path).

Definition at line 110 of file eos_mag.C.

References Lorene::Eos::Eos(), read_table(), and tablename.

## Eos_mag() [3/6]

Lorene::Eos_mag::Eos_mag | ( | const Eos_mag & |  | ) |

protected

Copy constructor.

References Eos_mag().

## Eos_mag() [4/6]

Lorene::Eos_mag::Eos_mag | ( | FILE * | fich | ) |

protected

Constructor from a binary file (created by the function `sauve(FILE*)` ).

This constructor is protected because any EOS construction from a binary file must be done via the function `Eos::eos_from_file(FILE*)` .

Definition at line 120 of file eos_mag.C.

References Lorene::Eos::Eos(), read_table(), and tablename.

## Eos_mag() [5/6]

Lorene::Eos_mag::Eos_mag | ( | ifstream & | ist,
|  | const char * | table )

protected

Constructor from a formatted file.

This constructor is protected because any EOS construction from a formatted file must be done via the function `Eos::eos_from_file`(ifstream& ) .

Parameters

  ist | input file stream containing a name as first line and the path to the directory containing the EOS file as second line
  table | Name of the file containing the EOS table

Definition at line 135 of file eos_mag.C.

References Lorene::Eos::Eos(), read_table(), and tablename.

## Eos_mag() [6/6]

Lorene::Eos_mag::Eos_mag | ( | ifstream & | ist | ) |

protected

Constructor from a formatted file.

This constructor is protected because any EOS construction from a formatted file must be done via the function `Eos::eos_from_file`(ifstream& ) .

Parameters

  ist | input file stream containing a name as first line and the full filename (including the path) containing the EOS file as second line

Definition at line 145 of file eos_mag.C.

References Lorene::Eos::Eos(), read_table(), and tablename.

## ~Eos_mag()

Lorene::Eos_mag::~Eos_mag | ( |  | ) |

virtual

Destructor.

Definition at line 158 of file eos_mag.C.

References Bfield, d2lp, dlpsdB, dlpsdlh, logh, and logp.

## Member Function Documentation

## calcule() [1/2]

void Lorene::Eos::calcule | ( | const Cmp & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Cmp & | resu ) const

protected inherited

General computational method for `Cmp` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 203 of file eos.C.

References Lorene::Cmp::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Cmp::get_etat(), Lorene::Tbl::get_etat(), Lorene::Cmp::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Cmp::set_etat_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Cmp::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Mtbl::t, Lorene::Tbl::t, and Lorene::Cmp::va.

## calcule() [2/2]

void Lorene::Eos::calcule | ( | const Scalar & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Scalar & | resu ) const

protected inherited

General computational method for `Scalar` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 268 of file eos.C.

References Lorene::Scalar::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Scalar::get_etat(), Lorene::Tbl::get_etat(), Lorene::Tensor::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Scalar::get_spectral_va(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Scalar::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Scalar::set_spectral_va(), Lorene::Mtbl::t, and Lorene::Tbl::t.

## der_ener_ent() [1/2]

Cmp Lorene::Eos::der_ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 430 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Cmp::get_mp().

## der_ener_ent() [2/2]

Scalar Lorene::Eos::der_ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 440 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Tensor::get_mp().

## der_ener_ent_p()

double Lorene::Eos_mag::der_ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  dln(e)/dln(H)

Implements Lorene::Eos.

Definition at line 520 of file eos_mag.C.

References Lorene::c_est_pas_fait().

## der_nbar_ent() [1/2]

Cmp Lorene::Eos::der_nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 407 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Cmp::get_mp().

## der_nbar_ent() [2/2]

Scalar Lorene::Eos::der_nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 417 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Tensor::get_mp().

## der_nbar_ent_p()

double Lorene::Eos_mag::der_nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  dln(n)/dln(H)

Implements Lorene::Eos.

Definition at line 508 of file eos_mag.C.

References Lorene::c_est_pas_fait().

## der_press_ent() [1/2]

Cmp Lorene::Eos::der_press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 452 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Cmp::get_mp().

## der_press_ent() [2/2]

Scalar Lorene::Eos::der_press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 462 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Tensor::get_mp().

## der_press_ent_p()

double Lorene::Eos_mag::der_press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  dln(p)/dln(H)

Implements Lorene::Eos.

Definition at line 533 of file eos_mag.C.

References Lorene::c_est_pas_fait().

## der_press_nbar_p()

double Lorene::Eos_mag::der_press_nbar_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  dln(p)/dln(n)

Definition at line 545 of file eos_mag.C.

References Lorene::c_est_pas_fait().

## ener_ent() [1/2]

Cmp Lorene::Eos::ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 363 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Cmp::get_mp().

## ener_ent() [2/2]

Scalar Lorene::Eos::ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 373 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Tensor::get_mp().

## ener_ent_p()

double Lorene::Eos_mag::ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the total energy density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  energy density e [unit: ], where

Implements Lorene::Eos.

Definition at line 373 of file eos_mag.C.

References Bfield, Bmax, d2lp, dlpsdB, dlpsdlh, Lorene::exp(), Lorene::Param::get_double_mod(), Lorene::Param::get_n_double_mod(), hmax, hmin, logh, and logp.

## eos_from_file() [1/2]

Eos * Lorene::Eos::eos_from_file | ( | FILE * | fich | ) |

static inherited

Construction of an EOS from a binary file.

The file must have been created by the function `sauve(FILE*)` .

Definition at line 177 of file eos_from_file.C.

References Eos(), and Lorene::fread_be().

## eos_from_file() [2/2]

Eos * Lorene::Eos::eos_from_file | ( | ifstream & | fich | ) |

static inherited

Construction of an EOS from a formatted file.

The fist line of the file must start by the EOS number, according to the following conventions:

- 1 = relativistic polytropic EOS (class `Eos_poly` ).
- 2 = Newtonian polytropic EOS (class `Eos_poly_newt` ).
- 3 = Relativistic incompressible EOS (class `Eos_incomp` ).
- 4 = Newtonian incompressible EOS (class `Eos_incomp_newt` ).
- 5 = Strange matter (MIT Bag model)
- 6 = Strange matter (MIT Bag model) with crust
- 10 = SLy4 (Douchin & Haensel 2001)
- 11 = FPS (Friedman-Pandharipande + Skyrme)
- 12 = BPAL12 (Bombaci et al. 1995)
- 13 = AkmalPR (Akmal, Pandharipande & Ravenhall 1998)
- 14 = BBB2 (Baldo, Bombaci & Burgio 1997)
- 15 = BalbN1H1 (Balberg 2000)
- 16 = GlendNH3 (Glendenning 1985, case 3)
- 17 = Compstar (Tabulated EOS for 2010 CompStar school)
- 18 = magnetized (tabulated) equation of state
- 19 = relativistic ideal Fermi gas at zero temperature (class `Eos_Fermi`)
- 100 = Multi-domain EOS (class `MEos` )
- 110 = Multi-polytropic EOS (class `Eos_multi_poly` )
- 120 = Fitted SLy4 (Shibata 2004)
- 121 = Fitted FPS (Shibata 2004)
- 122 = Fitted AkmalPR (Taniguchi 2005)

The second line in the file should contain a name given by the user to the EOS. The following lines should contain the EOS parameters (one parameter per line), in the same order than in the class declaration.

Definition at line 314 of file eos_from_file.C.

References Eos().

## get_name()

const char * Lorene::Eos::get_name | ( |  | ) | const

inherited

Returns the EOS name.

Definition at line 169 of file eos.C.

References name.

## identify()

int Lorene::Eos_mag::identify | ( |  | ) | const

virtual

Returns a number to identify the sub-classe of `Eos` the object belongs to.

Implements Lorene::Eos.

Definition at line 157 of file eos_from_file.C.

## mag_ent_p()

double Lorene::Eos_mag::mag_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

Computes the magnetisation.

Definition at line 460 of file eos_mag.C.

References Bfield, Bmax, d2lp, dlpsdB, dlpsdlh, Lorene::Param::get_double_mod(), Lorene::Param::get_n_double_mod(), hmax, hmin, logh, and logp.

## nbar_ent() [1/2]

Cmp Lorene::Eos::nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 338 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and nbar_ent_p().

## nbar_ent() [2/2]

Scalar Lorene::Eos::nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 348 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and nbar_ent_p().

## nbar_ent_p()

double Lorene::Eos_mag::nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the baryon density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  baryon density n [unit: ]

Implements Lorene::Eos.

Definition at line 330 of file eos_mag.C.

References Bfield, Bmax, d2lp, dlpsdB, dlpsdlh, Lorene::exp(), Lorene::Param::get_double_mod(), Lorene::Param::get_n_double_mod(), hmax, hmin, logh, and logp.

## operator!=()

bool Lorene::Eos_mag::operator!= | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (difference).

Implements Lorene::Eos.

Definition at line 196 of file eos_mag.C.

References Lorene::Eos::Eos(), and operator==().

## operator==()

bool Lorene::Eos_mag::operator== | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (egality).

Implements Lorene::Eos.

Definition at line 183 of file eos_mag.C.

References Lorene::Eos::Eos(), Lorene::Eos::identify(), and identify().

## operator>>()

ostream & Lorene::Eos_mag::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >>.

Implements Lorene::Eos.

Definition at line 207 of file eos_mag.C.

References tablename.

## press_ent() [1/2]

Cmp Lorene::Eos::press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 385 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and press_ent_p().

## press_ent() [2/2]

Scalar Lorene::Eos::press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 395 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and press_ent_p().

## press_ent_p()

double Lorene::Eos_mag::press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the pressure from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H

Returns
  pressure p [unit: ], where

Implements Lorene::Eos.

Definition at line 419 of file eos_mag.C.

References Bfield, Bmax, d2lp, dlpsdB, dlpsdlh, Lorene::Param::get_double_mod(), Lorene::Param::get_n_double_mod(), hmax, hmin, logh, and logp.

## read_table()

void Lorene::Eos_mag::read_table | ( |  | ) |

protected

Reads the file containing the table and initializes in the arrays `logh` , `logp` and `dlpsdlh` .

Definition at line 224 of file eos_mag.C.

References Bfield, Bmax, d2lp, dlpsdB, dlpsdlh, hmax, hmin, Lorene::log(), logh, logp, and tablename.

## sauve()

void Lorene::Eos_mag::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Eos.

Definition at line 171 of file eos_mag.C.

References Lorene::Eos::sauve(), and tablename.

## set_name()

void Lorene::Eos::set_name | ( | const char * | name_i | ) |

inherited

Sets the EOS name.

Definition at line 163 of file eos.C.

References name.

## Friends And Related Symbol Documentation

## Eos::eos_from_file

Eos * Eos::eos_from_file | ( | FILE * |  | ) |

friend

The construction functions from a file.

References Lorene::Eos::Eos().

## Member Data Documentation

## Bfield

Tbl* Lorene::Eos_mag::Bfield

protected

Table of .

Definition at line 103 of file eos_mag.h.

## Bmax

double Lorene::Eos_mag::Bmax

protected

Upper boundary of the magnetic field interval.

Definition at line 94 of file eos_mag.h.

## d2lp

Tbl* Lorene::Eos_mag::d2lp

protected

Table of .

Definition at line 112 of file eos_mag.h.

## dlpsdB

Tbl* Lorene::Eos_mag::dlpsdB

protected

Table of .

Definition at line 109 of file eos_mag.h.

## dlpsdlh

Tbl* Lorene::Eos_mag::dlpsdlh

protected

Table of .

Definition at line 106 of file eos_mag.h.

## hmax

double Lorene::Eos_mag::hmax

protected

Upper boundary of the log-enthalpy interval.

Definition at line 91 of file eos_mag.h.

## hmin

double Lorene::Eos_mag::hmin

protected

Lower boundary of the log-enthalpy interval.

Definition at line 88 of file eos_mag.h.

## logh

Tbl* Lorene::Eos_mag::logh

protected

Table of .

Definition at line 100 of file eos_mag.h.

## logp

Tbl* Lorene::Eos_mag::logp

protected

Table of .

Definition at line 97 of file eos_mag.h.

## name

char Lorene::Eos::name[100]

protected inherited

EOS name.

Definition at line 196 of file eos.h.

## tablename

string Lorene::Eos_mag::tablename

protected

Name of the file containing the tabulated data.

Definition at line 85 of file eos_mag.h.

The documentation for this class was generated from the following files:

- eos_mag.h
- eos_from_file.C
- eos_mag.C